<script lang="ts">
    import { quintOut } from 'svelte/easing'
    import LoadingOval from '$components/Icons/LoadingOval.svelte'
    import { awaitingAPI } from '$lib/fetch'

    export let variant = 'primary'
    export let href: string = undefined
</script>

{#if href}
    <a {href} role="button" class={variant}>
        <slot />
        {#if $awaitingAPI}
            <LoadingOval transition={{ duration: 200, easing: quintOut }} />
        {/if}
    </a>
{:else}
    <button class={variant} on:click>
        <slot />
        {#if $awaitingAPI}
            <LoadingOval transition={{ duration: 200, easing: quintOut }} />
        {/if}
    </button>
{/if}

<style lang="postcss">
    button,
    a[role='button'] {
        @apply w-full justify-center relative inline-flex px-6 py-3 rounded-lg z-0 border-opacity-0 mt-4;

        &:before {
            @apply absolute block inset-0 opacity-0 border-none transition-opacity duration-200 ease-out -z-10;
            content: '';
            border-radius: inherit;
        }

        &:hover :before {
            @apply opacity-100;
        }

        & > :global(svg) {
            @apply h-8 w-8 absolute inset-y-0 my-auto;

            &:last-child {
                @apply right-4;
            }
        }
    }

    .primary {
        @apply bg-gradient-to-r from-pink-600 via-purple-500 to-indigo-400 text-white font-semibold;

        &:before {
            @apply bg-gradient-to-r from-blue-600 via-teal-500 to-green-400;
        }
    }
</style>
